.include "1200def.inc"
.CSEG
.org 0
	rjmp RESET	; Reset Handler
	rjmp int1		; IRQ0 Handler	
	rjmp count     	; Timer1 Capture Handler
	nop 		; Analog Comparator Handler

.def temp = r16
.def temp2 = r17
.def temp3 = r12

.def tempsreg = r13
.def potenc = r19

.def count1h = r18
.def count1l = r20 

.def count22 = r10

.def count1hp = r2
.def count1lp = r3

.def    nh = r4
.def	nl = r5


.def countxx = r6
.def countxf = r7
.def starter = r8




.def cch = r0
.def ccl =r1

.def hb10 = r25
.def lb10 = r26

.def d1 =   r25
.def d0 =   r26



.def	drem16uL=r14 ;
.def	drem16uH=r15 ;



.def	dd16uL	=r27 ;  
.def	dd16uH	=r28 ;  
.def	m16u2	=r27		;result byte 2
.def	m16u3	=r28		;result byte 3 

.def	dv16uL	=r23 ;
.def	dv16uH	=r24 ;

.def    tempcorl =r23
.def    tempcorh =r24

.def	dcnt16u	=r21 ;
.def 	streg = r29



;========================================================
	;
reset:	cli ;  
	
	
	ldi temp , $40
	out gimsk , temp;   INT0
	
	ldi temp , 2
	out timsk , temp ;  
	
	ldi temp , $50	;   d
	out ddrd , temp
	ldi temp , $20
	out portd , temp
	
	ldi temp , $1c  ;   b
	out portb , temp
	ser temp
	out ddrb , temp
	
	ldi temp , 3
	out tccr0 , temp ;     64
	
	ldi temp , 0  
	out acsr , temp ; a off
	
	ldi temp , 0
	out wdtcr , temp ;  	
	
	clr streg
	clr starter
		
;==========================================================
	; 
	sbi ddrd , 1 ;  
	cli
	ldi temp , 3
	out mcucr , temp ;    

	;rcall seion ; sei
	ori streg , $2
	sei
	nop
	andi streg ,$fd ;  

nopp:	nop
	rjmp nopp ;   INT0
	
;================================================================
;  INT0
int1: 
	sbrs streg , 1
	rjmp int5
	reti ;  INT0  rcall seion

int5:	sbis portb , 2 
	rjmp iskra2 ;  
	
	in temp , mcucr
	sbrs temp , 0 ;   
	rjmp intt0    ;  
	
;===============================================
	
	; 
m8:
	;=========================
	;  nl nh	
povcor:	in  nl , tcnt0 
	mov nh , count22
	in  temp , tcnt0 
	cp nl , temp
	brne povcor
	cp nh , count22
	brne povcor
	;=========================
	
	clr temp
	out tcnt0 , temp ; 
	ldi temp , $2
	out tifr , temp ;  
	clr count22 ; 
		
	cli
	ldi temp2 , $0
	out gimsk , temp2;   INT0 

	sei ;rcall seion ; sei


	
	sbrs streg , 0 ;   
	rjmp cond0
	rcall miz
	;rcall miz
        andi streg ,$fe ;  

int1a: ;      ==================================================		

cond0:
	cbi ddrd , 1 ;  
	in temp , tcnt0
	
cond1:	sbis pind ,0
	rjmp cond1  ;  
	
	in potenc , tcnt0
	sub potenc , temp ; 
	sbi ddrd , 1 ;  	
	

	cpi potenc , 10 
	brsh pot100
	ldi potenc , 100 ;   
pot100:
	lsr potenc ;  2 =>  +/-5g  
	ldi temp , 90     ;11113- 90=4g ,1111- 60=1g, 50=0g
	add potenc , temp
	;===
	sbic pind , 5
	ldi potenc , 100 ; 0g
	;===
     ;===========================================================================
	cli
	ldi temp , $40
	out gimsk , temp;   INT0
	;============================
	ldi temp , 2
	out mcucr , temp ;     
        ;--------------
	;rcall seion ;sei
	ori streg , $2
	sei
	nop
	andi streg ,$fd
;=========================================================
	
	
	
	
;=========================================================
;  
;count1  count2 . count1h  count2 , count1l  count1
	sbis pind , 3 
	rjmp stab   ;    .
	rjmp xxon   ;   .
	
	

stab:	;
	inc countxx
	mov temp , countxx
	cpi temp , 20 ; 20   
	              ;  
	brlo n800a
	dec countxx ; -1+1=0  countxx
	
	;  	
	
	;   900  208d
	;    3   
	ldi temp  , $20
	ldi temp2 , $8d
	clc
	cpc count1l , temp2
	cpc count1h , temp
	brlo fx
        
        ldi temp , 30 ;   
		      ;3    3g/o
	sub countxf , temp ; 
	brcc fx2
	clr countxf
	rjmp fx2
	
	
	;   950  1ed6
	ldi temp  , $1e
	ldi temp2 , $d6
	clc
	cpc count1l , temp2
	cpc count1h , temp
	brlo fx
	
	ldi temp , 5 ;    0.5g/o
	sub countxf , temp ; 
	brcc fx2
	clr countxf
	rjmp fx2

fx:	;   980  1de5
	ldi temp  , $1d
	ldi temp2 , $e5
	clc
	cpc count1l , temp2
	cpc count1h , temp
	brlo fx1
	rjmp fx2 ;  950  980   
fx1:		
	ldi temp , 3 ;    0.3g/o
	add countxf , temp ; 
	brcc fx2 
	ser temp
	mov countxf , temp ; MAX -25.5 g
		
fx2:
	;=============
	;=============
	;=============
     ;

	;   1900  f6b
	ldi temp  , $f
	ldi temp2 , $6b
	clc
	cpc count1l , temp2
	cpc count1h , temp
	brlo x2100
	sbi portb , 3 ;  
n800a:	rjmp n800

x2100:	;   2100  df3
	ldi temp  , $d
	ldi temp2 , $f3
	clc
	cpc count1l , temp2
	cpc count1h , temp
	brlo x2100a
	rjmp n800 ;  1900  2100   
		   ; 
x2100a:	
	cbi portb , 3 ;  	
	rjmp n800

xxon:	;   .
	sbi portb , 3  ;  
	clr countxx
	clr countxf
;sbi portb , 4
;ldi temp , $80
;mov countxf , temp
		
;=========================================================
n800:	
	;  ================================
	;   600  30d4
	ldi temp  , $30
	ldi temp2 , $d4
	clc
	cpc count1l , temp2
	cpc count1h , temp
	brlo start
	rjmp n800b
start:	
	inc starter
	mov temp , starter
	;clc
	cpi temp , $3 ; 3   600
	brlo n800b
	cbi portb , 4 ;  
	;==========================================
	
n800b:	
	sbic pind , 2 ; ===================
	rjmp no ; ok
	nop
	nop
	sbic pind , 2
	rjmp n800b
	rjmp cik1 ; =============??????????
no:	
	mov temp , count22
	cpi temp , $24 ;800  
	brlo n800b    ; 
	
	;   800 ===================
	
m800:	cbi portb , 6 ; indikator pin 18 off

	cli
	ldi temp2 , $0
	out gimsk , temp2;   INT0 
	sei ;rcall seion ; sei


	sbi portb , 7 ; indikator pin 19
	
	ori streg , $1 ;   
	
	clr countxf ;   
	sbi portb , 3 ;  

cik1:	ldi temp , 255
	cp count22 , temp
	brne men
	cli	
men:	sbic pind , 2
	rjmp cik1
	sbic pind , 2
	rjmp cik1
	
	cbi portb , 2

povtorn800: 
	;  	
	;========================
	mov count1lp , count1l
	mov count1hp , count1h
	;========================
	in  count1l , tcnt0 
	mov count1h , count22
	in  temp , tcnt0 
	cp count1l , temp
	brne povtorn800 
	cp count1h , count22
	brne povtorn800
	
cik2:	sbis pind , 2
	rjmp cik2
	sbis pind , 2
	rjmp cik2
	
	sbi portb , 2 ;iskra
	
	rjmp m8
;====================================

;======================================
;======================================

intt0:  ; 
	ldi temp , $0
	out gimsk , temp;   INT0 off
	sei ;rcall seion ; sei

	
	;========================
	mov count1lp , count1l
	mov count1hp , count1h
	;========================
povtor:	
	
	in  count1l , tcnt0 
	mov count1h , count22
	in  temp , tcnt0 
	cp count1l , temp
	brne povtor
	cp count1h , count22
	brne povtor
	
	

	cbi portb , 2

  	;mov count1h , count1h
  	;mov count1l , count1l
	
	cbi portb , 7 ; indikator pin 19 off
	sbi portb , 6 ; indikator pin 18 on
	cpi count1h , $1d ;1000 o  .16,6
	brlo st1
	cbi portb , 6 ; indikator pin 18 off
	

st1:	; 
	; 1d4c

	ldi temp  , $1d
	clc
	cpi count1l , $4c
	cpc count1h , temp
	brlo st2


	clr cch
	clr ccl
	;b10 3700 = e74
	ldi hb10 ,  $e 
	ldi lb10 , $74
	rjmp rasch
	;=================================================	
st2:	

	; 
	; f6b
	ldi temp  , $f
	clc
	cpi count1l , $6b
	cpc count1h , temp
	brlo st3


	; ccc 5d
	ldi temp , $0
	mov cch , temp
	ldi temp , $5d
	mov ccl , temp
	;b10 ea1
	ldi hb10 , $e
	ldi lb10 , $a1
	rjmp rasch
	;======================================== 
st3:	cbi portb , 6 ; indikator pin 18 off

	; 
	; a77
	ldi temp  , $a
	clc
	cpi count1l , $77
	cpc count1h , temp
	brlo st4


	; ccc a2
	ldi temp , $0
	mov cch , temp
	ldi temp , $a2
	mov ccl , temp
	;b10 ee0
	ldi hb10 , $e
	ldi lb10 , $e0
	rjmp rasch
	;================================================== 
st4:
 	; 
	; 9c4
	ldi temp  , $9
	clc
	cpi count1l , $c4
	cpc count1h , temp
	brlo st5
		

	;CCC d1
	ldi temp , $0
	mov cch , temp
	ldi temp , $d1
	mov ccl , temp
	; B1O f1e
	ldi hb10 , $f
	ldi lb10 , $1e
	rjmp rasch
	;=================================================

st5:
 	; 
	; 4e2
	ldi temp  , $04
	clc
	cpi count1l , $e2
	cpc count1h , temp
	brlo st6
		

	;CCC 60
	ldi temp , $0
	mov cch , temp
	ldi temp , $60
	mov ccl , temp
	; B1O e7c
	ldi hb10 , $e
	ldi lb10 , $7c
	rjmp rasch

	;=================================================

st6:
	clr ccl
	clr cch
	; b10  d52
	ldi hb10 , $d
	ldi lb10 , $52
	rjmp rasch
;======================================================================================



;======================================================================================

rasch:
	;
	;b10 - potenc
	sub lb10 , potenc
	sbci hb10 , 0
	
	
	; 
	;===
	sbic pind , 5
	clr countxf ; 0g
	;===
	clr temp
	clc	
	add lb10 , countxf
	adc hb10 , temp

	;=========================
cortest:	;  


	mov temp , count1lp
	mov temp2, count1hp
	
	
	tst count1hp
	brne ed	 
	tst count1lp
	breq bed 
	
ed:	mov tempcorl , temp
	mov tempcorh , temp2
	
	lsr temp2
	ror temp
	lsr temp2
	ror temp
	
	add tempcorl , temp
	adc tempcorh , temp2
	
	cp nl , tempcorl
	cpc nh , tempcorh 
	brlo bed
	;=======
	mov temp , count1lp
	mov temp2, count1hp
	
	mov tempcorl , temp
	mov tempcorh , temp2
	
	add tempcorl , temp
	adc tempcorh , temp2
	
	cp  tempcorl , nl
	cpc tempcorh , nh
	brlo bed
	rjmp corok
bed:	
	mov temp , count1l
	mov temp2, count1h
	
	mov nl , temp
	mov nh , temp2
	
	mov count1lp , count1l
	mov count1hp , count1h
	
	lsr temp2
	ror temp
	
	add nl , temp
	adc nh , temp2
corok:	
	;
;***************************************************************************
;*
;* "mpy16u" - 16x16 Bit Unsigned Multiplication
;*
;* This subroutine multiplies the two 16-bit register variables 
;* mp16uH:mp16uL and mc16uH:mc16uL.
;* The result is placed in m16u3:m16u2:m16u1:m16u0.
;*  
;* Number of words	:14 + return
;* Number of cycles	:153 + return
;* Low registers used	:None
;* High registers used  :7 (mp16uL,mp16uH,mc16uL/m16u0,mc16uH/m16u1,m16u2,
;*                          m16u3,mcnt16u)	
;*
;***************************************************************************

;***** Subroutine Register Variables

;.def	mc16uL	=r16	count1	;multiplicand low byte 
;.def	mc16uH	=r17	count2	;multiplicand high byte
;.def	mp16uL	=r26	lb10	;multiplier low byte
;.def	mp16uH	=r25	hb10	;multiplier high byte
;.def	m16u0	=r26	lb10	;result byte 0 (LSB)
;.def	m16u1	=r25	hb10	;result byte 1
;.def	m16u2	=r27		;result byte 2
;.def	m16u3	=r28		;result byte 3 (MSB)
;.def	mcnt16u	=r16	temp		;loop counter

;***** Code

mpy16u:	clr	m16u3		;clear 2 highest bytes of result
	clr	m16u2
	ldi	temp , 16	;init loop counter
	lsr	hb10
	ror	lb10

m16u_1:	brcc	noad8		;if bit 0 of multiplier set
	add	m16u2 , count1l	;add multiplicand Low to byte 2 of res
	adc	m16u3 , count1h	;add multiplicand high to byte 3 of res
noad8:	ror	m16u3		;shift right result byte 3
	ror	m16u2		;rotate right result byte 2
	ror	hb10		;rotate result byte 1 and multiplier High
	ror	lb10		;rotate result byte 0 and multiplier Low
	dec	temp		;decrement loop counter
	brne	m16u_1		;if not done, loop more
	;ret




;
;***************************************************************************
;*
;* "div16u" - 16/16 Bit Unsigned Division
;*
;* This subroutine divides the two 16-bit numbers 
;* "dd8uH:dd8uL" (dividend) and "dv16uH:dv16uL" (divisor). 
;* The result is placed in "dres16uH:dres16uL" and the remainder in
;* "drem16uH:drem16uL".
;*  
;* Number of words	:19
;* Number of cycles	:235/251 (Min/Max)
;* Low registers used	:2 (drem16uL,drem16uH)
;* High registers used  :5 (dres16uL/dd16uL,dres16uH/dd16uH,dv16uL,dv16uH,
;*			    dcnt16u)
;*
;***************************************************************************

;***** Subroutine Register Variables

;.def	drem16uL=r14 ;
;.def	drem16uH=r15 ;

;.def  	d0 =     r26
;.def    d1 =     r25
;.def	dd16uL	=r27 ;  
;.def	dd16uH	=r28 ;  

;.def	dv16uL	=r16 ;
;.def	dv16uH	=r17 ;

;.def	dcnt16u	=r21 ;

	; 3600 , e10
	ldi dv16uh , $e
	ldi dv16ul , $10
	

;***** Code

div16u:	clr	drem16uL	;clear remainder Low byte
	sub	drem16uH,drem16uH;clear remainder High byte and carry
	ldi	dcnt16u,33	;init loop counter
d16u_1:	
	rol     d0
	rol     d1
	rol	dd16uL		;shift left dividend
	rol	dd16uH
	dec	dcnt16u		;decrement counter
	brne	d16u_2		;if done
	rjmp dend			;    return
d16u_2:	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL,dv16uL	;remainder = remainder - divisor
	sbc	drem16uH,dv16uH	;
	brcc	d16u_3		;if result negative
	add	drem16uL,dv16uL	;    restore remainder
	adc	drem16uH,dv16uH
	clc			;    clear carry to be shifted into result
	rjmp	d16u_1		;else
d16u_3:	sec			;    set carry to be shifted into result
	rjmp	d16u_1


dend:

;mov r9 , hb10
;mov r10 , lb10

;
	mov temp  , cch
	mov temp2 , ccl
	clc
	sbc     lb10 , temp2	
	sbc	hb10 , temp

;============================================================== 	
;acor:	;2
;***************************************************************************
;*
;* "mpy16u" - 16x16 Bit Unsigned Multiplication
;*
;* This subroutine multiplies the two 16-bit register variables 
;* mp16uH:mp16uL and mc16uH:mc16uL.
;* The result is placed in m16u3:m16u2:m16u1:m16u0.
;*  
;* Number of words	:14 + return
;* Number of cycles	:153 + return
;* Low registers used	:None
;* High registers used  :7 (mp16uL,mp16uH,mc16uL/m16u0,mc16uH/m16u1,m16u2,
;*                          m16u3,mcnt16u)	
;*
;***************************************************************************

;***** Subroutine Register Variables

;.def	mc16uL	=r16	nl	;multiplicand low byte 
;.def	mc16uH	=r17	nh	;multiplicand high byte
;.def	mp16uL	=r26	lb10	;multiplier low byte
;.def	mp16uH	=r25	hb10	;multiplier high byte
;.def	m16u0	=r26	lb10	;result byte 0 (LSB)
;.def	m16u1	=r25	hb10	;result byte 1
;.def	m16u2	=r27		;result byte 2
;.def	m16u3	=r28		;result byte 3 (MSB)
;.def	mcnt16u	=r16	temp		;loop counter

;***** Code

ampy16u:	
	clr	m16u3		;clear 2 highest bytes of result
	clr	m16u2
	ldi	temp,16	;init loop counter
	lsr	hb10
	ror	lb10

am16u_1:
	brcc	anoad8		;if bit 0 of multiplier set
	add	m16u2 , nl	;add multiplicand Low to byte 2 of res
	adc	m16u3 , nh	;add multiplicand high to byte 3 of res
anoad8:	ror	m16u3		;shift right result byte 3
	ror	m16u2		;rotate right result byte 2
	ror	hb10		;rotate result byte 1 and multiplier High
	ror	lb10		;rotate result byte 0 and multiplier Low
	dec	temp		;decrement loop counter
	brne	am16u_1		;if not done, loop more
	;ret


;mov r5 , m16u3 
;mov r6 , m16u2
;mov r7 , hb10
;mov r8 , lb10

;2
;***************************************************************************
;*
;* "div16u" - 16/16 Bit Unsigned Division
;*
;* This subroutine divides the two 16-bit numbers 
;* "dd8uH:dd8uL" (dividend) and "dv16uH:dv16uL" (divisor). 
;* The result is placed in "dres16uH:dres16uL" and the remainder in
;* "drem16uH:drem16uL".
;*  
;* Number of words	:19
;* Number of cycles	:235/251 (Min/Max)
;* Low registers used	:2 (drem16uL,drem16uH)
;* High registers used  :5 (dres16uL/dd16uL,dres16uH/dd16uH,dv16uL,dv16uH,
;*			    dcnt16u)
;*
;***************************************************************************

;***** Subroutine Register Variables

;.def	drem16uL=r14 ;
;.def	drem16uH=r15 ;

;.def  	d0 =     r26
;.def    d1 =     r25
;.def	dd16uL	=r27 ;  
;.def	dd16uH	=r28 ;  

;.def	dv16uL	=r16 ;
;.def	dv16uH	=r17 ;

;.def	dcnt16u	=r21 ;

	; 
	;mov dv16ul , count1lp
	;mov dv16uh , count1hp

;***** Code

adiv16u:
	clr	drem16uL	;clear remainder Low byte
	sub	drem16uH,drem16uH;clear remainder High byte and carry
	ldi	dcnt16u,33	;init loop counter
ad16u_1:	
	rol     d0
	rol     d1
	rol	dd16uL		;shift left dividend
	rol	dd16uH
	dec	dcnt16u		;decrement counter
	brne	ad16u_2		;if done
	rjmp adend			;    return
ad16u_2:
	rol	drem16uL	;shift dividend into remainder
	rol	drem16uH
	sub	drem16uL, count1lp ;dv16uL	;remainder = remainder - divisor
	sbc	drem16uH, count1hp ;dv16uH	;
	brcc	ad16u_3		   ;if result negative
	add	drem16uL, count1lp ;dv16uL	;    restore remainder
	adc	drem16uH, count1hp ;dv16uH
	clc			;    clear carry to be shifted into result
	rjmp	ad16u_1		;else
ad16u_3:
	sec			;    set carry to be shifted into result
	rjmp	ad16u_1
adend:
;==============================================================
;==============================================================
;
;
;==============================================================
; 
	cli
	ldi temp , $40
	out gimsk , temp;   INT0
	ldi temp , 3
	out mcucr , temp ;    
	
	;rcall seion ; sei
	ori streg , $2
	sei
	nop
	andi streg ,$fd
	
	; 
sr1:	 
	 
	cp hb10 ,count22 
	brlo iskra ; 
	brne sr1 ;  
sr2:	
	in temp3 , tcnt0 
	cp temp3 ,lb10 
	breq iskra
	brsh iskra
	brlo sr1 ;??????
	

iskra:	cli
	
        sbi portb , 2 ; 
	
	out gimsk , temp;   INT0 off
	sei ;rcall seion ; sei
	
is2:	sbis pind , 2 ;=========================
	rjmp is2
	;sbis pind , 2 ;         0  1
	;rjmp is2      ;=========================
	
	rjmp m8	
  ;=======================================================	
	; 
iskra2: 
	;sbi portb , 2 ; 
	;rjmp m8	
;clr ncor
;clr nh
	;!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	ldi temp , $0
	out gimsk , temp;   INT0 off
	sei ;rcall seion ; sei
	
povtor2:
 	in temp3 , tcnt0
	mov temp , count22
	
	in temp2 , tcnt0
	cp temp3 , temp2
	brne povtor2
	cp temp , count22
	brne povtor2
	;=========================
	;	
	mov  nl ,temp3 
	mov nh , temp
	
	;mov count1lp , count1l
	;mov count1hp , count1h
	;=========================
	
	clc
	sbc lb10 , temp3
	sbc hb10 , temp
;===============	
	brlo iskra ; e      
;===============
	clr temp
	out tcnt0 , temp
	ldi temp , $2
	out tifr , temp ;  
	clr count22
	

		; 
sr1a:	 
	sbis pind , 2
	rjmp m800 
	
	cp hb10 , count22 
	brlo iskra3 ; 
	brne sr1a ;  
sr2a:	
	in temp3 , tcnt0 
	cp temp3 ,lb10 
	breq iskra3
	brsh iskra3
	brlo sr1a ;????

iskra3:
        sbi portb , 2
	rjmp int1a	 
;============================================================
;============================================================
;============================================================
count:
	in tempsreg , sreg
	inc count22
	out sreg ,tempsreg
	reti	
		 
;=============================================================

timer:
	clr temp
ttt1:	inc temp
	brne ttt1
	ret
;=============================================================
miz:	

	ldi temp2 , 156
ttt2a:
	clr temp
ttt1a:	inc temp
	brne ttt1a
	
	inc temp2 
	brne ttt2a 
	
	cbi portb , 2 ;  iskra
	;;;;;;;;;;;;;;;;;;
	
	ldi temp2 , 156
		
ttt2b:		
	clr temp
ttt1b:	
	inc temp
	brne ttt1b
	
	inc temp2 
	brne ttt2b
	
	sbi portb , 2 ;iskra
	ret
;============================================================== 
;============================================================== 
;============================================================== 

